Subject: Re: [Sip] RE: [BEHAVE] Re: ICE deployment data before LC for RFC

From: Pyda Srisuresh <[email-masked]>
Date: Wed, 15 Aug 2007 20:28:17 -0700 (PDT)

Magnus,

I was out of town and just got back. Just catching up on the e-mails. Please
see my responses inline below.

regards,
suresh
--- Magnus Westerlund <[email-masked]> wrote:

> Suresh,
> 
> I would propose that you drop MMUSIC mailing listif responding to this 
> as you appear to want to discuss the removal of a BEHAVE milestone, 
> rather than ICE and its way forward. But I will leave it there to let 
> the MMUSIC people see my response.
> 
[suresh] I am not opposed to ICE moving forward. Please see below for my
objection to ICE.

> It seems most of the issues in this discussion is between, what I at 
> least thought was a specific way of performing the hole punching rather 
> than the general concept that I acknowledge has existed since the 
> creation of NATs. I will drop these items an respond to few of them.

[suresh] Sorry, the hole punchign techniques havent been there since the
conception of NATs. They came about  principally in the context of P2P
applications, much aftet the original NATs.
> 
> Pyda Srisuresh skrev:
> > --- Magnus Westerlund <[email-masked]> wrote:
> >>
> >> There also has been discussion about if there should be multiple 
> >> solutions etc. But, to my knowledge the consensus also there has been 
> >> that one solution is the way to go.
> >>
> > [suresh] I have not been part of the discussion pertaining to the merit of
> > multiple solutions vs single soultions. This may have been discussed in the
> > context of SIP and NAT traversal. So, I cant comment on this.
> 
> Yes, that was in the context of ICE. As my email was about that.
> 
> > 
> >> So Suresh, you and everyone else as participants in the IETF is 
> >> responsible for what you call HOLE PUNCHING TECHNIQUES are not an WG 
> >> item. 
> > 
> > [suresh] Magnus - I dont know what you are talking about. How do you mean I
> am
> > responsible for why the HOLE PUNCHING TECHNIQUE draft is not a WG item. The
> > ford-behave-app draft has been around for many years since the inception of
> > BEHAVE. Last I checked, The application milestone is no longer on BEHVAE
> > charter. I certainly am not responsible for removign the milestone.
> 
> This was written as reaction on how work gets done in the IETF. One or 
> more proponents goes out and sell their idea so that enough people are 
> interested to participate in the work on that idea. In cases the 
> proponents are not succesful in getting traction for the idea it rarely 
> goes anywhere. In the case of the ford-behave-app draft there has been 
> no support for keeping the milestone or more important, do the work.
> 

[suresh] I personally know of several applications using the TCP/UDP HOLE
PUNCHING techniques directly (not using ICE). Irrespective of whether the IETF
endorses design guidelines using HOLE PUNCHING techniques or not, this work
will continue. It is ironic to me why the WG chose not to take up design
guidelines using HOLE PUNCHING techniques as WG item. I cant explain it.  

> 
> > [suresh] Magnus - I have not been part of the consensus for ICE. However, I
> do
> > know ICE adapts the HOLE PUNCHING TECHNIQUES and the BCP recommendations
> > identified in ford-behave-app draft. Yet, neither of the ICE drafts (UDP or
> the
> > TCP version) refer the ford-behave-app draft or prior work on HOLE PUNCHING
> as
> > normative reference. This iS WRONG. 
> > 
> > I believe, the ICE drafts should refer the prior work (kegel work on UDP
> hole
> > punching, USENIX paper for TCP hole punching and ford-behave-app draft for
> > application traversal design) on which the ICE work is based.
> > 
> 
> I think you should review your sources here. The first version of 
> ford-beahve-app was submitted february 2005. At that point STUN (RFC 
> 3489 had been published in almost 2 years (March 2003). The first 
> individual version of ICE was submitted to IETF february 2003. I am not 
> going to untangle this, but if you are going down this path: Please have 
> you facts right.
> 
[suresh] Below is the chronology of the sources I am refering to. You can see
for yourself what I am talking about. Nothing complex to untagle.

a) http://alumnus.caltech.edu/~dank/peer-nat.html (Dec 98)- First documented
reference to UDP hole punching technique. 

b) draft-ford-midcom-nat-p2p-00.txt (Sept 03) - First known reference to TCP
hole punching technique and P2P application design guidelines

c) Peer-to-peer communication across NATs USENIX '05 paper (04/2005) - This is
derived from draft-ford-midcom-nat-p2p draft. Considerign that
draft-ford-midcom-nat-p2p draft expired, this is the first formal documented
reference to TCP hole punching

d) draft-ford-behave-app-05.txt (March '07) - This is the currently active
application design guidelines draft, derived from draft-ford-midcom-nat-p2p
draft.

e) draft-rosenberg-sipping-ice-00 (Feb 03) - First rev of ICE over UDP draft.
This uses UDP hole punching technique. The ICE draft currently in MMUSIC WG has
evolved and folds in a number of application design guidelines in
ford-midcom-nat-p2p and ford-behave-app drafts, besides the UDP HOLE PUNCHING
technique.

f) draft-ietf-mmusic-ice-tcp-00 (Mar 06) - First rev of ICE over TCP draft.
This uses TCP hole punching technique and folds in a number of application
design guidelines in ford-midcom-nat-p2p and ford-behave-app drafts.

I  believe, there should be acknowledgement where the acknowledgement is due.
The ICE drafts use the HOLE PUNCHING technique and adapt guidelines specified
in ford-behave-app draft. But none of a), c) or e)  are referred by the ICE
drafts (ICE and ICE-TCP).

> I am not denying that work commonly builds up on others. And that it is 
> common curtesy to reference such work. However, that is commonly done by 
> an informative reference. Normative references are for things that you 
> absolutely need to include to build interoperable implementations. 
> Please do review IESG statement on references:
> 
>
http://www.ietf.org/IESG/STATEMENTS/iesg-statement-normative-informative-references.txt

[suresh] Thanks for the pointer. The description is subject to individual
interpretation. For example, it says "Normative references specify documents
that must be read to understand or implement the technology in the new RFC". If
you describe the technique used inside a draft, does it make the technique
non-normative? I dont want to get into the nitty grittys on this.

I will be fine, if the ICE drafts referred the docs I mentioned even as
informational references.

> 
> 
> > On the one hand, IETF (IESG) has been adamant about the standard level of
> the
> > normative references for a proposes standard. Yet, it is ironic that when
> HOLE
> > PUNCHING  is normative to the design of ICE, the IETF is not allowing the
> HOLE
> > PUNCHING work to be standardized. 
> 
> Once more a missunderstanding about what it means to be a normative 
> reference in an RFC.
> 
[suresh] Please see my comment above.

> > 
> > Why is the IETF not allowing HOLE PUNCHING TECHNIQUES and P2P application
> > traversal identified in draft-ford-behave-app draft to move forward as a
> BCP WG
> > item?
> > 
> 
> As stated before. There is a clear lack of interest in this document. I 
> wished there wasn't. But the fact is that no-one except you have really 
> argued for it, not even your co-authors. We can't publish a document 
> where no-one reads and reviews it and stil claim that their exist 
> consensus behind it.

[suresh] Magnus - My co-authors are not arguing for it because they have given
up they can get anywhere with arguing. It is just that I didnt. 

regards,
suresh 

> 
> Regards
> 
> Magnus Westerlund
> 
> IETF Transport Area Director & TSVWG Chair
> ----------------------------------------------------------------------
> Multimedia Technologies, Ericsson Research EAB/TVM/M
> ----------------------------------------------------------------------
> Ericsson AB                | Phone +46 8 4048287
> Torshamsgatan 23           | Fax   +46 8 7575550
> S-164 80 Stockholm, Sweden | mailto: [email-masked]
> ----------------------------------------------------------------------
> 

_______________________________________________
Behave mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/behave

---

From: Magnus Westerlund <[email-masked]>
Date: Wed, 29 Aug 2007 10:53:40 +0200

Hi,

A couple of comments, but I don't see that we are going anywhere
productive.

First of all, I can agree with it being regretable that there aren't
energy in the WG to document what to consider when designing solutions.
But, I can't force people (much) to do things. There need to be
sufficient support. It is obvious that people will design applications
and protocols that will do hole punching and not use ICE and STUN.

Regarding the references, as you presented them earlier, it didn't
appear that they where prior art to the IETF work. Although, the common
courtesy is to reference where one have gotten the ideas, I think this
is not a simple case to find who is first with a idea. There also
usually a chain of refinements. Putting that history into a standards
document, is bloating it and mostly irrelevant to the one actually
implementing something.

Cheers

Magnus Westerlund